import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
// ignore: unused_import
import 'package:ui_sdk/props/UikTextProps.dart';
import 'package:flutter/material.dart';

import '../props/UikActionSheetProps.dart';

// ignore: must_be_immutable
class UikActionSheet extends UikWidget {
  // ignore: unused_field
  final WidgetType _widgetType;
  final UikActionSheetProps _uikActionSheetProps;
  UikActionSheet(this._widgetType, this._uikActionSheetProps)
      : super(_widgetType, _uikActionSheetProps);

  @override
  _UikActionSheetState createState() =>
      // ignore: no_logic_in_create_state
      _UikActionSheetState(_uikActionSheetProps);
}

class _UikActionSheetState extends State<UikActionSheet> {
  final UikActionSheetProps _uikActionSheetProps;
  _UikActionSheetState(this._uikActionSheetProps);

  void showBottomSheet(BuildContext context) {
    showModalBottomSheet(
      context: context,
      shape: const RoundedRectangleBorder(
        // <-- SEE HERE
        borderRadius: BorderRadius.vertical(
          top: Radius.circular(25.0),
        ),
      ),
      builder: (context) {
        if ((_uikActionSheetProps.widget != null)) {
          return SingleChildScrollView(child: _uikActionSheetProps.widget!);
        } else {
          return Container(
            decoration: BoxDecoration(
              color: Color(0xFF737373),
              border: Border.all(
                width: 0,
                color: Color(0xFF737373),
              ),
            ),
            child: Container(
              height: (_uikActionSheetProps.itemList.length == 1)
                  ? 250
                  : (_uikActionSheetProps.itemList.length == 2)
                      ? 300
                      : 400,
              decoration: BoxDecoration(
                color: Colors.white,
                borderRadius: BorderRadius.only(
                  topLeft: Radius.circular(20),
                  topRight: Radius.circular(20),
                ),
              ),
              child: Column(
                children: [
                  //Title starts

                  Container(
                    margin: EdgeInsets.only(
                      top: 40,
                      left: 10,
                      bottom: 10,
                    ),
                    child: Row(
                      mainAxisAlignment: MainAxisAlignment.start,
                      children: [
                        Text(
                          _uikActionSheetProps.title,
                          style: TextStyle(
                            fontSize: 35,
                            color: Colors.black,
                            fontWeight: FontWeight.bold,
                          ),
                        ),
                      ],
                    ),
                  ),

                  //Title Ends

                  //ListItems starts

                  Expanded(
                    child: ListView(
                      children: [
                        for (int i = 0;
                            i < _uikActionSheetProps.itemList.length;
                            i++) ...[
                          ListTile(
                            leading: Icon(Icons.star_border_outlined),
                            title: Text(_uikActionSheetProps.itemList[i]),
                            onTap: () {},
                          ),
                        ]
                      ],
                    ),
                  ),
                  //ListItems Ends

                  //cancel button starts

                  Container(
                    margin: EdgeInsets.all(10),
                    padding: EdgeInsets.all(10),

                    // ..................button baad mai lagaenge ...................

                    // child: UikButton(
                    //   onClick: () {
                    //     Navigator.pop(context);
                    //   },
                    //   //  backgroundColor: Color(0xFFF5F5F5),
                    //   widthSize: double.infinity,
                    //   // heightSize: 80,
                    // ),

                    // ..................button baad mai lagaenge ...................
                  ),
                  // MouseRegion(
                  //   cursor: SystemMouseCursors.click,
                  //   child: GestureDetector(
                  //     onTap: () {
                  //       Navigator.pop(context);
                  //     },
                  //     child: Container(
                  //       height: 70,
                  //       margin: EdgeInsets.all(10),
                  //       padding: EdgeInsets.all(3),
                  //       decoration: BoxDecoration(
                  //         borderRadius: BorderRadius.circular(8),
                  //         color: Color(0xFFF5F5F5),
                  //         border: Border.all(
                  //           width: 1,
                  //           color: Color(0xFFF5F5F5),
                  //         ),
                  //       ),
                  //       child: Row(
                  //         crossAxisAlignment: CrossAxisAlignment.center,
                  //         mainAxisAlignment: MainAxisAlignment.center,
                  //         children: [
                  //           Text(
                  //             'Cancel',
                  //             style: TextStyle(color: Colors.black),
                  //           ),
                  //         ],
                  //       ),
                  //     ),
                  //   ),
                  // ),

                  //cancel buttons ends
                ],
              ),
            ),
          );
        }
      },
    );
  }

  @override
  Widget build(BuildContext context) {
    return FloatingActionButton(
      // child: (_uikActionSheetProps.widget != null)
      //     ? _uikActionSheetProps.widget!
      //     : const Text(''),
      child: Icon(Icons.add),
      onPressed: () => showBottomSheet(context),
    );
  }
}
//, "Price: low to high", "New First","Popular First"