import 'dart:ui';

import 'package:sizer/sizer.dart';
import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/props/UikAnimatedImageProps.dart';
import 'package:ui_sdk/props/UikTextProps.dart';
import 'package:flutter/material.dart';
import 'package:google_fonts/google_fonts.dart';
import 'package:ui_sdk/utils/pubsub/localpubsub.dart';
import 'package:ui_sdk/utils/UikActionListner.dart';

class UikAnimatedImage extends UikWidget {
  WidgetType _widgetType;
  UikAnimatedImageProps _uikAnimatedImageProps;
  UikAnimatedImage(this._widgetType, this._uikAnimatedImageProps)
      : super(_widgetType, _uikAnimatedImageProps);

  @override
  _UikAnimatedImageState createState() =>
      _UikAnimatedImageState(_uikAnimatedImageProps);
}

class _UikAnimatedImageState extends State<UikAnimatedImage> {
  UikAnimatedImageProps _uikAnimatedImageProps;
  _UikAnimatedImageState(this._uikAnimatedImageProps);

  @override
  Widget build(BuildContext context) {
    final imageAction = this._uikAnimatedImageProps.action;
    return GestureDetector(
      onTap: () async {
        await executeUikWidgetAction(imageAction!);
      },
      child: Stack(
        // fit: StackFit.expand,
        children: <Widget>[
          // Text('0' * 10000),
          Container(
            width: _uikAnimatedImageProps.width,
            height: _uikAnimatedImageProps.height,
            margin: EdgeInsets.only(
                top: _uikAnimatedImageProps.topMargin,
                left: _uikAnimatedImageProps.leftMargin,
                right: _uikAnimatedImageProps.rightMargin,
                bottom: _uikAnimatedImageProps.bottomMargin),
            decoration: BoxDecoration(
              borderRadius: BorderRadius.only(
                topLeft: Radius.circular(_uikAnimatedImageProps.topLeftRadius),
                topRight:
                    Radius.circular(_uikAnimatedImageProps.topRightRadius),
                bottomLeft:
                    Radius.circular(_uikAnimatedImageProps.bottomLeftRadius),
                bottomRight:
                    Radius.circular(_uikAnimatedImageProps.bottomRightRadius),
              ),
              image: DecorationImage(
                fit: BoxFit.fill,
                image: NetworkImage(
                  _uikAnimatedImageProps.url,
                ),
              ),
            ),
          ),
          Center(
            child: ClipRect(
              // <-- clips to the 200x200 [Container] below
              child: BackdropFilter(
                filter: ImageFilter.blur(
                  sigmaX: 5.0,
                  sigmaY: 5.0,
                ),
                child: Container(
                  alignment: Alignment.center,
                  width: _uikAnimatedImageProps.width,
                  height: _uikAnimatedImageProps.height,
                  margin: EdgeInsets.only(
                      top: _uikAnimatedImageProps.topMargin,
                      left: _uikAnimatedImageProps.leftMargin,
                      right: _uikAnimatedImageProps.rightMargin,
                      bottom: _uikAnimatedImageProps.bottomMargin),
                  decoration: BoxDecoration(
                    borderRadius: BorderRadius.only(
                      topLeft:
                          Radius.circular(_uikAnimatedImageProps.topLeftRadius),
                      topRight: Radius.circular(
                          _uikAnimatedImageProps.topRightRadius),
                      bottomLeft: Radius.circular(
                          _uikAnimatedImageProps.bottomLeftRadius),
                      bottomRight: Radius.circular(
                          _uikAnimatedImageProps.bottomRightRadius),
                    ),
                  ),
                  child:
                      Text(_uikAnimatedImageProps.action!.tap.type.toString()),
                ),
              ),
            ),
          ),
        ],
      ),
    );
  }
}
