import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:flutter/material.dart';
import 'package:ui_sdk/props/UikDiscountProps.dart';

class UikDiscount extends UikWidget {
  // ignore: unused_field
  final WidgetType _widgetType;
  final UikDiscountProps _uikDiscountProps;

  UikDiscount(this._widgetType, this._uikDiscountProps)
      : super(_widgetType, _uikDiscountProps);

  @override
  _UikDiscountState createState() =>
      // ignore: no_logic_in_create_state
      _UikDiscountState(_uikDiscountProps);
}

class _UikDiscountState extends State<UikDiscount> {
  // ignore: unused_field
  final UikDiscountProps _uikDiscountProps;

  _UikDiscountState(this._uikDiscountProps);

  @override
  Widget build(BuildContext context) {
    return Column(
      children: [
        Container(
          margin: EdgeInsets.only(
              top: _uikDiscountProps.topMargin,
              left: _uikDiscountProps.sideMargin,
              right: _uikDiscountProps.sideMargin,
              bottom: _uikDiscountProps.bottomMargin),
          child: Container(
            height: 80,
            decoration: BoxDecoration(
                borderRadius: BorderRadius.circular(10.0),
                color: const Color(0xFFF5F5F5)),
            child: Row(
              mainAxisAlignment: MainAxisAlignment.spaceAround,
              crossAxisAlignment: CrossAxisAlignment.center,
              children: [
                _uikDiscountProps.icon,
                Column(
                  crossAxisAlignment: CrossAxisAlignment.start,
                  mainAxisAlignment: MainAxisAlignment.center,
                  children: [
                    _uikDiscountProps.centerText1,
                    _uikDiscountProps.centerText2
                  ],
                ),
                _uikDiscountProps.button
              ],
            ),
          ),
        ),
      ],
    );
  }
}
