import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/props/UikTextProps.dart';
import 'package:flutter/material.dart';

import '../props/UikGroupAvatarProps.dart';

class UikGroupAvatar extends UikWidget {
  WidgetType _widgetType;
  UikGroupAvatarProps _uikGroupAvatarProps;
  UikGroupAvatar(this._widgetType, this._uikGroupAvatarProps)
      : super(_widgetType, _uikGroupAvatarProps);

  @override
  _UikGroupAvatarState createState() =>
      _UikGroupAvatarState(_uikGroupAvatarProps);
}

class _UikGroupAvatarState extends State<UikGroupAvatar> {
  UikGroupAvatarProps _uikGroupAvatarProps;
  _UikGroupAvatarState(this._uikGroupAvatarProps);

  int index = 0;
  @override
  Widget build(BuildContext context) {
    return Container(
      width: 80,
      height: 80,
      child: Row(
        crossAxisAlignment: CrossAxisAlignment.center,
        mainAxisAlignment: MainAxisAlignment.center,
        children: [
          Column(
            mainAxisAlignment: MainAxisAlignment.center,
            children: [
              Container(
                child: (_uikGroupAvatarProps.leftIcon != null)
                    ? GestureDetector(
                        child: _uikGroupAvatarProps.plusIcon,
                        onTap: () {},
                      )
                    : (Container()),
              ),
            ],
          ),
          SizedBox(
            width: (_uikGroupAvatarProps.leftIcon != null) ? 6.44 : null,
          ),
          ListView.builder(
            reverse: true,
            shrinkWrap: true,
            scrollDirection: Axis.horizontal,
            itemCount: _uikGroupAvatarProps.list.length,
            itemBuilder: (context, index) {
              return Align(
                widthFactor: 0.6, //distance of image from another image
                child: CircleAvatar(
                  backgroundColor: Colors.white,
                  child: CircleAvatar(
                    radius: 18,

                    backgroundImage: NetworkImage(_uikGroupAvatarProps
                        .list[index++]), // Provide your custom image
                  ),
                ),
              );
            },
          ),
          SizedBox(
            width: (_uikGroupAvatarProps.rightIcon != null) ? 6.44 : null,
          ),
          Container(
            child: (_uikGroupAvatarProps.rightIcon != null)
                ? GestureDetector(
                    child: _uikGroupAvatarProps.plusIcon,
                    onTap: () {},
                  )
                : (Container()),
          ),
        ],
      ),
    );
  }
}
