import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:flutter/material.dart';

import '../props/UikListTileProps.dart';
import '../utils/UikActionListner.dart';

class UikListTile extends UikWidget {
  WidgetType _widgetType;
  UikListTileProps _uikListTileProps;
  UikListTile(this._widgetType, this._uikListTileProps)
      : super(_widgetType, _uikListTileProps);

  @override
  _UikListTileState createState() => _UikListTileState(_uikListTileProps);
}

class _UikListTileState extends State<UikListTile> {
  UikListTileProps _uikListTileProps;

  _UikListTileState(this._uikListTileProps);

  @override
  Widget build(BuildContext context) {
    /* return Container(
      // height: 100.0,
      width: double.infinity,
      margin: EdgeInsets.only(
        left: _uikListTileProps.leftMargin,
        right: _uikListTileProps.rightMargin,
        top: _uikListTileProps.topMargin,
        bottom: _uikListTileProps.bottomMargin,
      ),
      padding: EdgeInsets.only(
        left: _uikListTileProps.leftPadding,
        right: _uikListTileProps.rightPadding,
        top: _uikListTileProps.topPadding,
        bottom: _uikListTileProps.bottomPadding,
      ),
      decoration: BoxDecoration(
        color: Color(int.parse(_uikListTileProps.backgroundColor)),
        borderRadius: BorderRadius.circular(10.0),
      ),
      child: Row(
        mainAxisAlignment: MainAxisAlignment.start,
        children: [
          _uikListTileProps.leading!,
          const SizedBox(width: 20.0),
          SizedBox(
            width: MediaQuery.of(context).size.width * 0.6,
            child: Column(
              mainAxisAlignment: MainAxisAlignment.start,
              crossAxisAlignment: CrossAxisAlignment.start,
              children: [
                _uikListTileProps.title!,
                const SizedBox(height: 4.0),
                if (_uikListTileProps.subtitle != null)
                  _uikListTileProps.subtitle!,
              ],
            ),
          ),
          // const SizedBox(height: 20.0),
          const Spacer(),
          if (_uikListTileProps.trailing != null) _uikListTileProps.trailing!,
        ],
      ),
    ); */
    return Padding(
      padding: EdgeInsets.fromLTRB(
        _uikListTileProps.leftMargin,
        _uikListTileProps.topMargin,
        _uikListTileProps.rightMargin,
        _uikListTileProps.bottomMargin,
      ),
      child: GestureDetector(
        onTap: () async {
          await executeUikWidgetAction(_uikListTileProps.action);
        },
        child: ListTile(
          leading: _uikListTileProps.leading,
          title: _uikListTileProps.title,
          subtitle: _uikListTileProps.subtitle,
          trailing: _uikListTileProps.trailing,
        ),
      ),
    );
  }
}
