import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:flutter/material.dart';

import '../props/UikListViewBuilderProps.dart';

class UikListViewBuilder extends UikWidget {
  WidgetType _widgetType;
  UikListViewBuilderProps _uikListViewBuilderProps;
  UikListViewBuilder(this._widgetType, this._uikListViewBuilderProps)
      : super(_widgetType, _uikListViewBuilderProps);

  @override
  _UikListViewBuilderState createState() =>
      _UikListViewBuilderState(_uikListViewBuilderProps);
}

class _UikListViewBuilderState extends State<UikListViewBuilder> {
  UikListViewBuilderProps _uikListViewBuilderProps;

  _UikListViewBuilderState(this._uikListViewBuilderProps);

  @override
  Widget build(BuildContext context) {
    return SizedBox(
      height: MediaQuery.of(context).size.height * 0.65,
      child: ListView.builder(
        shrinkWrap: true,
        itemCount: _uikListViewBuilderProps.children.length,
        scrollDirection: Axis.horizontal,
        itemBuilder: (context, index) =>
            _uikListViewBuilderProps.children[index],
      ),
    );
  }
}
