import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/props/UikNavbarProps.dart';
import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/props/UikNavbarProps.dart';
import 'package:flutter/material.dart';
import 'package:google_fonts/google_fonts.dart';
// import 'package:login/widgets/UikButton/UikButton.dart';
// import '../UikIcon/uikIcon.dart';

class UikNavbar extends UikWidget implements PreferredSizeWidget {
  WidgetType _widgetType;
  UikNavbarProps _uikNavbarProps;
  UikNavbar(this._widgetType, this._uikNavbarProps)
      : super(_widgetType, _uikNavbarProps);

  @override
  _UikNavbarState createState() => _UikNavbarState(_uikNavbarProps);

  @override
  Size get preferredSize => throw UnimplementedError();
}

class _UikNavbarState extends State<UikNavbar> {
  UikNavbarProps _uikNavbarProps;
  _UikNavbarState(this._uikNavbarProps);

  @override
  Widget build(BuildContext context) => (_uikNavbarProps.size == 'small')
      ? Container(
          // color: (transparent==true)?,
          height: 56,
          child: AppBar(
            leadingWidth: 30,
            elevation: 0,
            // elevation: (_uikNavbarProps.transparency == true) ? 0 : null,
            backgroundColor: (_uikNavbarProps.transparency == true)
                ? Colors.transparent
                : _uikNavbarProps.backgroundColor,
            // foregroundColor: Colors.black,
            // backgroundColor: bg,
            leading: Container(
              margin: EdgeInsets.only(left: 16), //changes
              // color: Colors.amber,
              child: IconButton(
                padding: const EdgeInsets.all(0.0),
                onPressed: () {},
                icon: _uikNavbarProps.leftIcon!,
                iconSize: 30,
                color: Colors.black,
              ),
            ),
            actions: [
              Container(
                // color: Colors.amber,
                margin: EdgeInsets.only(right: 16),
                padding: EdgeInsets.only(right: 7),
                child: Column(
                  mainAxisAlignment: MainAxisAlignment.center,
                  children: [
                    if (_uikNavbarProps.triggerElementType == 'icon') ...[
                      _uikNavbarProps.triggerIcon!
                    ] else if (_uikNavbarProps.triggerElementType ==
                        'button') ...[
                      Container(
                          height: 36, child: _uikNavbarProps.triggerButton!),
                    ] else if (_uikNavbarProps.triggerElementType ==
                        'action') ...[
                      Container(
                        child: _uikNavbarProps.triggerAction!,
                        // color: Colors.black,
                      ),
                    ]
                  ],
                ),
              )
            ],
            centerTitle: true,
            title: Column(
              mainAxisAlignment: MainAxisAlignment.start,
              crossAxisAlignment: CrossAxisAlignment.center,
              children: [
                if (_uikNavbarProps.titleText == null) ...[
                  Container()
                ] else if (_uikNavbarProps.subtitleText == null) ...[
                  Center(
                    child: Text(
                      _uikNavbarProps.titleText!,
                      style: GoogleFonts.poppins(
                        textStyle: Theme.of(context).textTheme.bodyMedium,
                        fontSize: 16,
                        fontWeight: FontWeight.w500,
                        color: Colors.black,
                      ),
                    ),
                  ),
                ] else ...[
                  Center(
                    child: Text(
                      _uikNavbarProps.titleText!,
                      style: GoogleFonts.poppins(
                        textStyle: Theme.of(context).textTheme.bodyMedium,
                        fontSize: 16,
                        fontWeight: FontWeight.w500,
                        color: Colors.black,
                      ),
                    ),
                  ),
                  Center(
                    child: Text(
                      _uikNavbarProps.subtitleText!,
                      style: GoogleFonts.poppins(
                        textStyle: Theme.of(context).textTheme.bodyMedium,
                        fontSize: 12,
                        fontWeight: FontWeight.w500,
                        color: Color(0xff3e3e3e),
                      ),
                    ),
                  )
                ]
              ],
            ),

            // backgroundColor: bgcolor,
          ),
        )
      : Container(
          height: (_uikNavbarProps.subtitleText != null) ? (142) : (114),
          // margin: EdgeInsets.only(top: 100),
          color: (_uikNavbarProps.transparency == true)
              ? Colors.transparent
              : _uikNavbarProps.backgroundColor,
          child: Column(
            children: [
              AppBar(
                // toolbarOpacity: 0,
                elevation: 0,
                backgroundColor: (_uikNavbarProps.transparency == true)
                    ? Colors.transparent
                    : _uikNavbarProps.backgroundColor,

                foregroundColor: Colors.black,
                // (subtitletxt==null)? (): (),
                toolbarHeight: 56,
                leadingWidth: 40,
                automaticallyImplyLeading: false,

                leading: (_uikNavbarProps.leftIcon == null)
                    ? (Container(
                        height: 56,
                      ))
                    : Container(
                        padding: EdgeInsets.only(top: 10, left: 5),
                        // color: Colors.amber,
                        child: Column(
                          mainAxisAlignment: MainAxisAlignment.start,
                          children: [
                            _uikNavbarProps.leftIcon!,
                          ],
                        ),
                      ),

                //second element
                actions: [
                  Container(
                    padding: EdgeInsets.only(top: 10, right: 7),
                    // color: Colors.amber,
                    child: Column(
                      mainAxisAlignment: MainAxisAlignment.start,
                      // crossAxisAlignment: CrossAxisAlignment.end,
                      children: [
                        if (_uikNavbarProps.triggerElementType == 'icon') ...[
                          _uikNavbarProps.triggerIcon!
                        ] else if (_uikNavbarProps.triggerElementType ==
                            'button') ...[
                          _uikNavbarProps.triggerButton!,
                        ] else if (_uikNavbarProps.triggerElementType ==
                            'action') ...[
                          _uikNavbarProps.triggerAction!,
                        ]
                        // else if (rightElementType == 'button') ...[
                        //   Container(
                        //     margin: EdgeInsets.fromLTRB(0, 10, 10, 68),
                        //     // padding: EdgeInsets.fromLTRB(16, 16, 16, 16),
                        //     width: btnwidth,
                        //     height: btnheight,
                        //     // padding: EdgeInsets.fromLTRB(0, 16, 0, 16),
                        //     child: UikButton(
                        //       backgroundColor: btncolor,
                        //       text: btntext,
                        //       textColor: btntextColor,
                        //       textSize: btntextSize,
                        //     ),
                        //   )
                        // ] else if (rightElementType == 'action') ...[
                        //   Container(
                        //       width: actionWidth,
                        //       height: actionHeight,
                        //       // color: Colors.black,
                        //       margin: EdgeInsets.fromLTRB(0, 16, 16, 0),
                        //       child: Center(
                        //           child: Text(
                        //         actionText,
                        //         style: GoogleFonts.poppins(
                        //           textStyle:
                        //               Theme.of(context).textTheme.bodyText1,
                        //           fontSize: actiontextSize,
                        //           fontWeight: FontWeight.w500,
                        //           color: actionTextColor,
                        //         ),
                        //       )))
                        // ]
                      ],
                    ),
                  )
                ],
              ),
              Row(
                // titleTextCenter is a prop that centers the titleText prop

                mainAxisAlignment: (_uikNavbarProps.titleTextCenter == true)
                    ? MainAxisAlignment.center
                    : MainAxisAlignment.start,
                children: [
                  Container(
                      // color: Colors.red,
                      margin: EdgeInsets.only(left: 16),
                      child: Column(
                        mainAxisAlignment: MainAxisAlignment.center,
                        crossAxisAlignment: CrossAxisAlignment.center,
                        children: [
                          if (_uikNavbarProps.subtitleText == null) ...[
                            Container(
                              // color: Colors.red,
                              child: Text(
                                // overflow: TextOverflow.ellipsis,
                                // maxLines: 1,
                                _uikNavbarProps.titleText!,
                                style: GoogleFonts.poppins(
                                  textStyle:
                                      Theme.of(context).textTheme.bodyMedium,
                                  fontSize: 32,
                                  fontWeight: FontWeight.w600,
                                  color: Colors.black,
                                ),
                              ),
                            ),
                          ] else ...[
                            Container(
                              child: Text(
                                _uikNavbarProps.titleText!,
                                style: GoogleFonts.poppins(
                                  textStyle:
                                      Theme.of(context).textTheme.bodyMedium,
                                  fontSize: 32,
                                  fontWeight: FontWeight.w600,
                                  color: Colors.black,
                                ),
                              ),
                            ),
                            Container(
                              // color: Colors.red,
                              margin: EdgeInsets.only(top: 4),
                              child: Text(
                                _uikNavbarProps.subtitleText!,
                                style: GoogleFonts.poppins(
                                  textStyle:
                                      Theme.of(context).textTheme.bodyMedium,
                                  fontSize: 16,
                                  fontWeight: FontWeight.w400,
                                  color: Color(0xff3e3e3e),
                                ),
                              ),
                            )
                          ]
                        ],
                      )),
                ],
              )
            ],
          ),
        );

  @override
  Size get preferredSize => (_uikNavbarProps.subtitleText != null)
      ? const Size.fromHeight(142.0)
      : const Size.fromHeight(114.0);
}
