import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/props/UikPageControlProps.dart';
// ignore: file_names
import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/props/UikPageControlProps.dart';
import 'package:flutter/material.dart';
import 'package:smooth_page_indicator/smooth_page_indicator.dart';

class UikPageControl extends UikWidget {
  WidgetType _widgetType;
  UikPageControlProps _uikPageControlProps;
  UikPageControl(this._widgetType, this._uikPageControlProps)
      : super(_widgetType, _uikPageControlProps);

  @override
  _UikPageControlState createState() =>
      _UikPageControlState(_uikPageControlProps);
}

class _UikPageControlState extends State<UikPageControl> {
  UikPageControlProps _uikPageControlProps;
  _UikPageControlState(this._uikPageControlProps);
  int currentPage = 0;
  final pageController = PageController(initialPage: 0);

  @override
  Widget build(BuildContext context) {
    final pages = PageView(
        onPageChanged: (int page) {
          setState(() {
            currentPage = page;
          });
        },
        controller: pageController,
        children: _uikPageControlProps.list);

    return Container(
      // padding: const EdgeInsets.all(30),
      // color: Colors.amber,
      width: _uikPageControlProps.contentWidth,
      height: _uikPageControlProps.contentHeight,
      child: Stack(
        children: [
          pages,
          Align(
            alignment: Alignment.bottomCenter,
            child: Container(
              // width: 100,
              height: 13,
              margin: EdgeInsets.only(bottom: 20),
              padding: const EdgeInsets.all(4),
              decoration: BoxDecoration(
                borderRadius: const BorderRadius.all(Radius.circular(4.0)),
                color: (_uikPageControlProps.isBackground == true)
                    ? (_uikPageControlProps.backgroundColor)
                    : (Colors.transparent),
              ),

              child: Row(
                mainAxisSize: MainAxisSize.min,
                mainAxisAlignment: MainAxisAlignment.center,
                children: [
                  SmoothPageIndicator(
                    controller: pageController,
                    count: _uikPageControlProps.list.length,
                    effect: ExpandingDotsEffect(
                        activeDotColor: _uikPageControlProps.activeDotColor,
                        dotColor: _uikPageControlProps.dotColor,
                        dotHeight: _uikPageControlProps.dotHeight,
                        dotWidth: _uikPageControlProps.dotWidth,
                        spacing: _uikPageControlProps.spacing,
                        radius: _uikPageControlProps.dotRadius,
                        expansionFactor: 2.1),
                  ),
                ],
              ),
            ),
          ),
        ],
      ),
    );
  }
}
/*
    return Scaffold(
      body: Column(
        mainAxisAlignment: MainAxisAlignment.spaceAround,
        children: [
          //page view
          // SizedBox(
          //   height: boxheight,
          //   child: PageView(
          //     controller: pagecontroller,
          //     children: pages,
          //   ),
          // ),

          // dot indicator
          SmoothPageIndicator(
            controller: pagecontroller,
            count: _uikPageControlProps.pages,
            effect: ExpandingDotsEffect(
                activeDotColor: _uikPageControlProps.activeDotColor,
                dotColor: _uikPageControlProps.dotColor,
                dotHeight: _uikPageControlProps.dotHeight,
                dotWidth: _uikPageControlProps.dotWidth,
                spacing: _uikPageControlProps.spacing,
                radius: _uikPageControlProps.radius,
                expansionFactor: 2.1),
          ),
        ],
      ),
    );*/
  
