import 'package:ui_sdk/components/UikText.dart';
import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/props/UikTextProps.dart';
import 'package:flutter/material.dart';
import 'package:google_fonts/google_fonts.dart';

import '../props/UikProductImageTitlePriceCardProps.dart';
import '../utils/UikActionListner.dart';

class UikProductImageTitlePriceCard extends UikWidget {
  WidgetType _widgetType;
  UikProductImageTitlePriceCardProps _uikProductImageTitlePriceCardProps;
  UikProductImageTitlePriceCard(
      this._widgetType, this._uikProductImageTitlePriceCardProps)
      : super(_widgetType, _uikProductImageTitlePriceCardProps);

  @override
  _UikProductImageTitlePriceCardState createState() =>
      _UikProductImageTitlePriceCardState(_uikProductImageTitlePriceCardProps);
}

class _UikProductImageTitlePriceCardState
    extends State<UikProductImageTitlePriceCard> {
  UikProductImageTitlePriceCardProps _uikProductImageTitlePriceCardProps;
  _UikProductImageTitlePriceCardState(this._uikProductImageTitlePriceCardProps);

  @override
  Widget build(BuildContext context) {
    return InkWell(
      onTap: () async {
        await executeUikWidgetAction(
            _uikProductImageTitlePriceCardProps.action);
      },
      child: Column(
        children: [
          Expanded(
            flex: 2,
            child: Container(
              padding: const EdgeInsets.all(8.0),
              decoration: BoxDecoration(
                color: Color(0xFFF9F0E9),
                borderRadius: const BorderRadius.only(
                  topLeft: Radius.circular(8.0),
                  topRight: Radius.circular(8.0),
                  bottomRight: Radius.circular(8.0),
                  bottomLeft: Radius.circular(8.0),
                ),
                image: DecorationImage(
                  fit: BoxFit.fill,
                  image: NetworkImage(
                    _uikProductImageTitlePriceCardProps.imageUrl,
                  ),
                ),
              ),
            ),
          ),
          const SizedBox(height: 8.0),
          Expanded(
            child: Container(
              decoration: const BoxDecoration(
                borderRadius: BorderRadius.only(
                  bottomLeft: Radius.circular(8.0),
                  bottomRight: Radius.circular(8.0),
                ),
              ),
              child: Column(
                mainAxisAlignment: MainAxisAlignment.start,
                crossAxisAlignment: CrossAxisAlignment.start,
                children: [
                  _uikProductImageTitlePriceCardProps.title!,
                  const SizedBox(height: 8.0),
                  Row(
                    children: [
                      (_uikProductImageTitlePriceCardProps.price != null)
                          ? _uikProductImageTitlePriceCardProps.price!
                          : Text(""),
                      (_uikProductImageTitlePriceCardProps.discountedPrice !=
                              null)
                          ? const SizedBox(width: 4.0)
                          : Text(""),
                      (_uikProductImageTitlePriceCardProps.discountedPrice !=
                              null)
                          ? _uikProductImageTitlePriceCardProps.discountedPrice!
                          : Text(""),
                    ],
                  ),
                ],
              ),
            ),
          ),
        ],
      ),
    );
  }
}
