import 'package:google_fonts/google_fonts.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/props/UikIconProps.dart';
import "package:flutter/material.dart";

import '../props/UikChipsProps.dart';
import '../props/UikRowTextProps.dart';
import 'UikIcon.dart';
import 'UikWidget.dart';

class UikRowText extends UikWidget {
  WidgetType _widgetType;
  UikRowTextProps _uikRowTextProps;
  UikRowText(this._widgetType, this._uikRowTextProps)
      : super(_widgetType, _uikRowTextProps);

  @override
  _UikRowTextState createState() => _UikRowTextState(_uikRowTextProps);
}

class _UikRowTextState extends State<UikRowText> {
  UikRowTextProps _uikRowTextProps;
  _UikRowTextState(this._uikRowTextProps);

  @override
  Widget build(BuildContext context) {
    return Container(
      //color: Colors.red,
      width: _uikRowTextProps.width,
      height: _uikRowTextProps.height,
      margin: EdgeInsets.fromLTRB(
          _uikRowTextProps.leftMargin,
          _uikRowTextProps.topMargin,
          _uikRowTextProps.rightMargin,
          _uikRowTextProps.bottomMargin),
      child: Row(
        mainAxisAlignment: MainAxisAlignment.start,
        children: [
          Text(
            _uikRowTextProps.text!,
            style: GoogleFonts.getFont(
              _uikRowTextProps.fontFamily,
              fontSize: _uikRowTextProps.size,
              fontWeight: _uikRowTextProps.fontWeight,
              color: _uikRowTextProps.color,
            ),
          ),
          const SizedBox(
            width: 220,
          ),
          _uikRowTextProps.icon!
        ],
      ),
    );
  }
}
