// dog_card.dart

import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/props/UikTextProps.dart';
import 'package:flutter/material.dart';

import '../props/UikSelectProps.dart';

class UikSelect extends UikWidget {
  WidgetType _widgetType;
  UikSelectProps _UikSelectProps;
  UikSelect(this._widgetType, this._UikSelectProps)
      : super(_widgetType, _UikSelectProps);

  @override
  _UikSelectState createState() => _UikSelectState(_UikSelectProps);
}

class _UikSelectState extends State<UikSelect> {
  UikSelectProps _UikSelectProps;
  _UikSelectState(this._UikSelectProps);

  var ContainerHeight = 41.0;
  var ContainerRadius = 0.0;
  var ContainerBorderColor = Colors.white;
  var ContainerBackgroundColor = Colors.white;

  @override
  Widget build(BuildContext context) {
    if (_UikSelectProps.size == "Small") ContainerHeight = 31.0;
    if (_UikSelectProps.size == "Large") ContainerHeight = 51.0;
    if (_UikSelectProps.Border == true)
      ContainerBorderColor = Color(0xFF9E9E9E);
    if (_UikSelectProps.Corner == "Recktangle") ContainerRadius = 8.0;
    if (_UikSelectProps.Corner == "Rounded") ContainerRadius = 30.0;
    if (_UikSelectProps.Disable == true)
      ContainerBackgroundColor = Color(0xFFE5E5E5);
    return Column(
      children: [
        AbsorbPointer(
          absorbing: _UikSelectProps.Disable,
          child: Container(
            // color: Colors.blue,
            child: Column(
              children: [
                if (_UikSelectProps.Heading)
                  Container(
                    width: 200,
                    child: Align(
                      alignment: Alignment.topLeft,
                      child: Container(
                        padding: EdgeInsets.fromLTRB(0, 5, 0, 10),
                        child: const Text(
                          "LABEL",
                          textAlign: TextAlign.left,
                          style: TextStyle(
                              fontSize: 14,
                              fontWeight: FontWeight.w500,
                              color: Colors.black),
                        ),
                      ),
                    ),
                  ),
                const SizedBox(
                  width: 17,
                ),
                // Select Box Container
                Container(
                  width: 200,
                  height: ContainerHeight,
                  // color: Color(0xFF9E9E9E),
                  decoration: BoxDecoration(
                    border: Border.all(color: ContainerBorderColor),
                    color: ContainerBackgroundColor,
                    borderRadius:
                        BorderRadius.all(Radius.circular(ContainerRadius)),
                  ),
                  child: Row(
                    children: [
                      SizedBox(width: 11),
                      if (_UikSelectProps.noIcon == false)
                        Container(
                          child: _UikSelectProps.avatar == null
                              ? Container(
                                  height: 13.0,
                                  width: 13.0,
                                  decoration: new BoxDecoration(
                                    color: Color(0xFF9E9E9E),
                                    shape: BoxShape.circle,
                                  ),
                                )
                              : _UikSelectProps.avatar,
                          decoration: BoxDecoration(
                              border:
                                  Border.all(color: ContainerBackgroundColor)),
                        ),
                      if (_UikSelectProps.noIcon == false) SizedBox(width: 11),
                      Container(
                        child: Container(
                          child: const Text(
                            "Search",
                            style: TextStyle(
                              fontWeight: FontWeight.w500,
                              fontSize: 13,
                              color: Color(0xFF9E9E9E),
                            ),
                          ),
                          width: 41,
                          height: 16,
                        ),
                        decoration: BoxDecoration(
                            border:
                                Border.all(color: ContainerBackgroundColor)),
                      ),
                      Spacer(),
                      MouseRegion(
                        cursor: SystemMouseCursors.click,
                        child: GestureDetector(
                          onTap: () => {},
                          child: _UikSelectProps.rightIcon,
                        ),
                      ),
                      const SizedBox(
                        width: 10,
                      )
                    ],
                  ),
                ),
              ],
            ),
          ),
        ),
      ],
    );
  }
}
