import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/props/UikTextProps.dart';
import 'package:flutter/material.dart';

import '../props/UikTabProps.dart';

class UikTab extends UikWidget {
  WidgetType _widgetType;
  UikTabProps _uikTabProps;
  UikTab(this._widgetType, this._uikTabProps)
      : super(_widgetType, _uikTabProps);

  @override
  _UikTabState createState() => _UikTabState(_uikTabProps);
}

class _UikTabState extends State<UikTab> with TickerProviderStateMixin {
  UikTabProps _uikTabProps;
  _UikTabState(this._uikTabProps);
  late TabController _tabController;
  @override
  void initState() {
    // super.initState();
    _tabController =
        TabController(length: _uikTabProps.list.length, vsync: this);
  }

  int val = 0;
  @override
  Widget build(BuildContext context) {
    return Column(
      children: [
        Container(
          // width: 400,
          child: TabBar(
            splashBorderRadius: (_uikTabProps.isBorder != null)
                ? BorderRadius.circular(25)
                : null,
            indicator: (_uikTabProps.isBorder != null)
                ? BoxDecoration(
                    color: _uikTabProps.indicatorColor,
                    borderRadius: (_uikTabProps.onlyTopBorderRadius != 0.0)
                        ? BorderRadius.only(
                            topRight: Radius.circular(
                                _uikTabProps.onlyTopBorderRadius),
                            topLeft: Radius.circular(
                                _uikTabProps.onlyTopBorderRadius),
                          )
                        : (_uikTabProps.borderRadius != 0.0)
                            ? BorderRadius.circular(_uikTabProps.borderRadius)
                            : null,
                    //  border: Border.all(color: Colors.green),
                  )
                : null,
            onTap: (value) {
              setState(() {
                val = value;
              });
            },

            padding: (_uikTabProps.isBorder != null) ? EdgeInsets.zero : null,
            //indicatorPadding: (widget.isBorder == true) ? EdgeInsets.zero : null,
            labelPadding:
                (_uikTabProps.isBorder != null) ? EdgeInsets.zero : null,
            physics: (_uikTabProps.isBorder != null)
                ? NeverScrollableScrollPhysics()
                : null,
            isScrollable: (_uikTabProps.isBorder != null) ? true : false,

            indicatorColor: (_uikTabProps.isBorder != null)
                ? Colors.transparent
                : _uikTabProps.indicatorColor,
            labelColor: _uikTabProps.labelColor,
            unselectedLabelColor: _uikTabProps.unselectedLabelColor,
            controller: _tabController,
            indicatorSize: TabBarIndicatorSize.label,
            tabs: <Widget>[
              for (int i = 0; i < _uikTabProps.list.length; i++) ...[
                Container(
                  padding: (_uikTabProps.isBorder != null)
                      ? EdgeInsets.fromLTRB(_uikTabProps.gapBetweenTabs, 0,
                          _uikTabProps.gapBetweenTabs, 0)
                      : null,
                  decoration: (_uikTabProps.isBorder != null)
                      ? BoxDecoration(
                          borderRadius:
                              (_uikTabProps.onlyTopBorderRadius != 0.0)
                                  ? BorderRadius.only(
                                      topRight: Radius.circular(
                                          _uikTabProps.onlyTopBorderRadius),
                                      topLeft: Radius.circular(
                                          _uikTabProps.onlyTopBorderRadius),
                                    )
                                  : (_uikTabProps.borderRadius != 0.0)
                                      ? BorderRadius.circular(
                                          _uikTabProps.borderRadius)
                                      : null,
                          border: (i != val)
                              ? Border.all(color: Colors.black, width: 1)
                              : null,
                        )
                      : null,
                  child: Tab(
                    icon: Text(_uikTabProps.list[i]),
                  ),
                )
              ],
            ],
          ),
        ),
      ],
    );
  }
}
