import 'package:ui_sdk/components/WidgetType.dart';
import "package:flutter/material.dart";
import '../props/UikThreeColumnTileListProps.dart';
import '../utils/UikActionListner.dart';
import 'UikWidget.dart';

class UikThreeColumnTileList extends UikWidget {
  WidgetType _widgetType;
  UikThreeColumnTileListProps _uikThreeColumnTileListProps;
  UikThreeColumnTileList(this._widgetType, this._uikThreeColumnTileListProps)
      : super(_widgetType, _uikThreeColumnTileListProps);

  @override
  _UikThreeColumnTileListState createState() =>
      _UikThreeColumnTileListState(_uikThreeColumnTileListProps);
}

class _UikThreeColumnTileListState extends State<UikThreeColumnTileList> {
  final UikThreeColumnTileListProps _uikThreeColumnTileListProps;

  _UikThreeColumnTileListState(this._uikThreeColumnTileListProps);

  int selectedButtonIndex = -1;

  @override
  Widget build(BuildContext context) {
    return Container(
      height: _uikThreeColumnTileListProps.height,
      padding: EdgeInsets.fromLTRB(
        _uikThreeColumnTileListProps.leftMargin,
        _uikThreeColumnTileListProps.topMargin,
        _uikThreeColumnTileListProps.rightMargin,
        _uikThreeColumnTileListProps.bottomMargin,
      ),
      child: ListView.builder(
        shrinkWrap: true,
        itemCount: _uikThreeColumnTileListProps.tiles.length,
        itemBuilder: (context, index) {
          return GestureDetector(
            onTap: () async {
              setState(() {
                selectedButtonIndex = index;
              });

              print(_uikThreeColumnTileListProps.actionList[index].tap.type);

              await executeUikWidgetAction(
                  _uikThreeColumnTileListProps.actionList[index]);
            },
            child: Container(
              margin: const EdgeInsets.only(bottom: 20.0),
              child: Row(
                mainAxisAlignment: MainAxisAlignment.start,
                children: [
                  Container(
                    height: 24.0,
                    width: 24.0,
                    decoration: BoxDecoration(
                      shape: BoxShape.circle,
                      color: selectedButtonIndex == index
                          ? const Color(0xFFFEE440)
                          : Colors.white,
                      border: Border.all(
                        color: Colors.grey,
                      ),
                    ),
                    child: selectedButtonIndex == index
                        ? const Icon(
                            Icons.check,
                            color: Colors.black,
                          )
                        : null,
                  ),
                  const SizedBox(width: 16.0),
                  _uikThreeColumnTileListProps.tiles[index],
                ],
              ),
            ),
          );
        },
      ),
    );
  }
}
