import 'package:ui_sdk/components/WidgetType.dart';
import "package:flutter/material.dart";
import '../props/UikThreeColumnTileProps.dart';
import 'UikWidget.dart';

class UikThreeColumnTile extends UikWidget {
  WidgetType _widgetType;
  UikThreeColumnTileProps _uikThreeColumnTileProps;
  UikThreeColumnTile(this._widgetType, this._uikThreeColumnTileProps)
      : super(_widgetType, _uikThreeColumnTileProps);

  @override
  _UikThreeColumnTileState createState() =>
      _UikThreeColumnTileState(_uikThreeColumnTileProps);
}

class _UikThreeColumnTileState extends State<UikThreeColumnTile> {
  UikThreeColumnTileProps _uikThreeColumnTileProps;
  _UikThreeColumnTileState(this._uikThreeColumnTileProps);

  @override
  Widget build(BuildContext context) {
    return Container(
      margin: EdgeInsets.only(
        top: _uikThreeColumnTileProps.topMargin,
        bottom: _uikThreeColumnTileProps.bottomMargin,
        right: _uikThreeColumnTileProps.rightMargin,
        left: _uikThreeColumnTileProps.leftMargin,
      ),
      child: Column(
        mainAxisAlignment: MainAxisAlignment.start,
        crossAxisAlignment: CrossAxisAlignment.start,
        children: [
          _uikThreeColumnTileProps.text1,
          const SizedBox(height: 4.0),
          _uikThreeColumnTileProps.text2,
          const SizedBox(height: 4.0),
          _uikThreeColumnTileProps.text3,
        ],
      ),
    );
  }
}
