import 'dart:ui';
// import 'package:ui_sdk/datastores/order.dart';
import 'package:ui_sdk/models/emptyPlan.dart';
import 'package:ui_sdk/models/emptySdkObject.dart';
import 'package:ui_sdk/models/emptyWidgetObject.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
// import 'package:date_format/date_format.dart';

import 'package:intl/intl.dart';

Map<String, dynamic> planConvertor(dynamic body) {
  // STEPS:
  // (1) extract the values from body of response
  // (2) generate an empty object for that component
  // (3) inserting that empty component into the datastore
  // (4) generate an empty widget object {id,uiType}
  // (5) inserting the emptywidget object in orderWidget for rendering

  // print(body);
  print(body.runtimeType);                                                    
  String headingText = body['plan']['name'];

  String subtitleText = body['plan']['description'];
  String price = body['plan']['pricing']['price']['value'];
  String duration = body['plan']['pricing']['singlePaymentForDuration']['unit'];

  for (int i = 0; i < 3; i++) {
    List<dynamic> perks = body['plan']['perks']['values'];
    emptyMembershipCard["perks"] = perks;
  }

  emptyMembershipCard["headingText"] = headingText;
  emptyMembershipCard["subtitleText"] = subtitleText;
  emptyMembershipCard["price"] = price.toString();
  emptyMembershipCard["duration"] = duration;

  planDataStore["membership"] = emptyMembershipCard;

  var obj1 = EmptyWidgetObj();
  obj1.mp["id"] = "membership";
  obj1.mp["uiType"] = "UikMembership";
  planWidget.insert(1, obj1.mp);

  emptySdkObject["widgets"] = planWidget;
  emptySdkObject["dataStore"] = planDataStore;

  print(emptySdkObject);
  return emptySdkObject;
}

var planDataStore = {
  "navbar": {
    "id": "navbar",
    "size": "large",
    "transparency": "false",
    "backgroundColor": "0xfffefefe",
    "titleText": "Membership Plans",
    "triggerElementType": "icon",
    "triggerIcon": {
      "id": "titleIcon",
      "iconVal": "0xf0164",
      "backgroundColor": "0xFFFFFFFF",
      "padding": "0.0",
      "iconSize": "27.0",
      "action": {
        "tap": {
          "type": "UIK_OPEN_WEB",
          "data": {
            "url":
                "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
          }
        }
      }
    },
    "action": {
      "tap": {
        "type": "UIK_OPEN_WEB",
        "data": {
          "url":
              "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
        }
      }
    }
  },
  "divider": {
    "id": "divider",
    "dividerColor": "0xFF000000",
    "widthSize": "543.0",
    "corner": "rectangle",
    "dividerSize": "large"
  },
  "headline3": {
    "id": "headline3",
    "text": "Membership Plans",
    "color": "0xff212121",
    "bottomMargin": 0.0,
    "size": "32",
    "fontWeight": FontWeight.w600,
    "leftMargin": 16.0,
    "topMargin": 10.0,
    "action": {
      "tap": {
        "type": "UIK_OPEN_WEB",
        "data": {
          "url":
              "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
        }
      }
    }
  },
  "titleTabBar": {
    "id": "titleTabBar",
    "ll": [
      {
        "id": "titleIcon",
        "iconVal": "0xf107",
        "backgroundColor": "0xFFFFFFFF",
        "padding": "0.0",
        "iconSize": "27.0",
        "action": {
          "tap": {
            "type": "UIK_OPEN_WEB",
            "data": {
              "url":
                  "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
            }
          }
        }
      },
      {
        "id": "titleIcon",
        "iconVal": "0xe59c",
        "backgroundColor": "0xFFFFFFFF",
        "padding": "0.0",
        "iconSize": "27.0",
        "action": {
          "tap": {
            "type": "UIK_OPEN_WEB",
            "data": {
              "url":
                  "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
            }
          }
        }
      },
      {
        "id": "titleIcon",
        "iconVal": "0xf36e",
        "backgroundColor": "0xFFFFFFFF",
        "padding": "0.0",
        "iconSize": "27.0",
        "action": {
          "tap": {
            "type": "UIK_OPEN_WEB",
            "data": {
              "url":
                  "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
            }
          }
        }
      },
      {
        "id": "titleIcon",
        "iconVal": "0xf0063",
        "backgroundColor": "0xFFFFFFFF",
        "padding": "0.0",
        "iconSize": "27.0",
        "action": {
          "tap": {
            "type": "UIK_OPEN_WEB",
            "data": {
              "url":
                  "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
            }
          }
        }
      },
    ],
    "backgroundColor": "0xFFFFFFFF",
    "indicatorColor": "0xFF212121",
    "topMargin": "18.74",
    "isBorder": "false"
  },
};

var planWidget = [
  // {"id": "navbar", "uiType": "UikNavbar"},
  {"id": "headline3", "uiType": "UikText"},
  // {"id": "divider", "uiType": "UikDivider"},
  // {"id": "titleTabBar" , "uiType": "UikTabBar"}
];
// print(planDataStore);
