import 'package:ui_sdk/components/UikIcon.dart';
import 'package:ui_sdk/components/UikImage.dart';
import 'package:ui_sdk/components/UikTags.dart';
import 'package:ui_sdk/generated/json/base/json_convert_content.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:ui_sdk/props/UikButtonProps.dart';
import 'package:ui_sdk/props/UikHomeCardFourProps.dart';
import 'package:ui_sdk/props/UikHomeCardOneProps.dart';
import 'package:ui_sdk/props/UikHomeCardThreeProps.dart';
import 'package:ui_sdk/props/UikHomeCardTwoProps.dart';
import 'package:ui_sdk/props/UikIconProps.dart';
import 'package:ui_sdk/props/UikImageProps.dart';
import 'package:ui_sdk/props/UikTagsProps.dart';
import 'package:ui_sdk/props/UikTextProps.dart';
import 'package:flutter/material.dart';

import '../../components/UikText.dart';
import '../../components/WidgetType.dart';

UikHomeCardFourProps $UikHomeCardFourPropsFromJson(Map<String, dynamic> json) {
  final UikHomeCardFourProps uikHomeCardFourProps = UikHomeCardFourProps();
  final String? id = jsonConvert.convert<String>(json['id']);
  if (id != null) {
    uikHomeCardFourProps.id = id;
  }

  final String? text = jsonConvert.convert<String>(json['text']);
  if (text != null) {
    uikHomeCardFourProps.text =
        UikText(WidgetType.UikText, UikTextProps.fromJson(json['text']));
  }

  final String? image = jsonConvert.convert<String>(json['image']);
  if (image != null) {
    uikHomeCardFourProps.image = UikImage(
      WidgetType.UikText,
      UikImageProps.fromJson(
        json['image'],
      ),
    );
  }

  final String? tag = jsonConvert.convert<String>(json['tag']);
  if (tag != null) {
    uikHomeCardFourProps.tag =
        UikTags(WidgetType.UikText, UikTagsProps.fromJson(json['tag']));
  }

  final UikAction? action = jsonConvert.convert<UikAction>(json['action']);
  if (action != null) {
    uikHomeCardFourProps.action = action;
  }
  return uikHomeCardFourProps;
}
