import 'package:ui_sdk/components/UikIcon.dart';
import 'package:ui_sdk/components/UikText.dart';
import 'package:ui_sdk/generated/json/base/json_convert_content.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:ui_sdk/props/UikButtonProps.dart';
import 'package:ui_sdk/props/UikChipsProps.dart';
import 'package:ui_sdk/props/UikMyOrderProps.dart';
import 'package:ui_sdk/props/UikIconProps.dart';
import 'package:flutter/material.dart';
import 'package:ui_sdk/props/UikTextProps.dart';

import '../../components/UikAvatar.dart';
import '../../components/WidgetType.dart';
import '../../props/UikAvatarProps.dart';

UikMyOrderProps $UikMyOrderPropsFromJson(Map<String, dynamic> json) {
  final UikMyOrderProps uikMyOrderProps = UikMyOrderProps();
  final String? id = jsonConvert.convert<String>(json['id']);
  if (id != null) {
    uikMyOrderProps.id = id;
  }

  final double? leftMargin = jsonConvert.convert<double>(json['leftMargin']);
  if (leftMargin != null) {
    uikMyOrderProps.leftMargin = leftMargin;
  }

  final double? rightMargin = jsonConvert.convert<double>(json['rightMargin']);
  if (rightMargin != null) {
    uikMyOrderProps.rightMargin = rightMargin;
  }

  final double? topMargin = jsonConvert.convert<double>(json['topMargin']);
  if (topMargin != null) {
    uikMyOrderProps.topMargin = topMargin;
  }

  final double? bottomMargin =
      jsonConvert.convert<double>(json['bottomMargin']);
  if (bottomMargin != null) {
    uikMyOrderProps.bottomMargin = bottomMargin;
  }

  final String? firstText = jsonConvert.convert<String>(json['firstText']);
  if (firstText != null) {
    uikMyOrderProps.firstText =
        UikText(WidgetType.UikText, UikTextProps.fromJson(json['firstText']));
  }
  final String? secondText = jsonConvert.convert<String>(json['secondText']);
  if (secondText != null) {
    uikMyOrderProps.secondText =
        UikText(WidgetType.UikText, UikTextProps.fromJson(json['secondText']));
  }
  final String? thirdText = jsonConvert.convert<String>(json['thirdText']);
  if (thirdText != null) {
    uikMyOrderProps.thirdText =
        UikText(WidgetType.UikText, UikTextProps.fromJson(json['thirdText']));
  }
  final String? fourthText = jsonConvert.convert<String>(json['fourthText']);
  if (fourthText != null) {
    uikMyOrderProps.fourthText =
        UikText(WidgetType.UikText, UikTextProps.fromJson(json['fourthText']));
  }

  final String? imageUrl = jsonConvert.convert<String>(json['imageUrl']);
  if (imageUrl != null) {
    uikMyOrderProps.imageUrl = imageUrl;
  }
  final String? secondimageUrl =
      jsonConvert.convert<String>(json['secondimageUrl']);
  if (secondimageUrl != null) {
    uikMyOrderProps.secondimageUrl = secondimageUrl;
  }

  final UikAction? action = jsonConvert.convert<UikAction>(json['action']);
  if (action != null) {
    uikMyOrderProps.action = action;
  }

  return uikMyOrderProps;
}
