import 'package:ui_sdk/components/UikIcon.dart';
import 'package:ui_sdk/components/UikText.dart';
import 'package:ui_sdk/generated/json/base/json_convert_content.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:ui_sdk/props/UikButtonProps.dart';
import 'package:ui_sdk/props/UikChipsProps.dart';
import 'package:ui_sdk/props/UikTotalProps.dart';
import 'package:ui_sdk/props/UikIconProps.dart';
import 'package:flutter/material.dart';
import 'package:ui_sdk/props/UikTextProps.dart';

import '../../components/UikAvatar.dart';
import '../../components/WidgetType.dart';
import '../../props/UikAvatarProps.dart';

UikTotalProps $UikTotalPropsFromJson(Map<String, dynamic> json) {
  final UikTotalProps uikTotalProps = UikTotalProps();
  final String? id = jsonConvert.convert<String>(json['id']);
  if (id != null) {
    uikTotalProps.id = id;
  }

  final double? leftMargin = jsonConvert.convert<double>(json['leftMargin']);
  if (leftMargin != null) {
    uikTotalProps.leftMargin = leftMargin;
  }

  final double? rightMargin = jsonConvert.convert<double>(json['rightMargin']);
  if (rightMargin != null) {
    uikTotalProps.rightMargin = rightMargin;
  }

  final double? topMargin = jsonConvert.convert<double>(json['topMargin']);
  if (topMargin != null) {
    uikTotalProps.topMargin = topMargin;
  }

  final double? bottomMargin =
      jsonConvert.convert<double>(json['bottomMargin']);
  if (bottomMargin != null) {
    uikTotalProps.bottomMargin = bottomMargin;
  }

  final String? firstText = jsonConvert.convert<String>(json['firstText']);
  if (firstText != null) {
    uikTotalProps.firstText =
        UikText(WidgetType.UikText, UikTextProps.fromJson(json['firstText']));
  }
  final String? secondText = jsonConvert.convert<String>(json['secondText']);
  if (secondText != null) {
    uikTotalProps.secondText =
        UikText(WidgetType.UikText, UikTextProps.fromJson(json['secondText']));
  }
  final String? thirdText = jsonConvert.convert<String>(json['thirdText']);
  if (thirdText != null) {
    uikTotalProps.thirdText =
        UikText(WidgetType.UikText, UikTextProps.fromJson(json['thirdText']));
  }
  final String? fourthText = jsonConvert.convert<String>(json['fourthText']);
  if (fourthText != null) {
    uikTotalProps.fourthText =
        UikText(WidgetType.UikText, UikTextProps.fromJson(json['fourthText']));
  }

  final UikAction? action = jsonConvert.convert<UikAction>(json['action']);
  if (action != null) {
    uikTotalProps.action = action;
  }

  return uikTotalProps;
}
