import 'package:ui_sdk/generated/json/base/json_convert_content.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:ui_sdk/props/UikAccordionProps.dart';
import 'package:flutter/material.dart';
import 'package:ui_sdk/utils/extensions.dart';

import '../../components/UikContainerText.dart';
import '../../components/UikIcon.dart';
import '../../components/UikImage.dart';
import '../../components/UikText.dart';
import '../../components/WidgetType.dart';
import '../../props/UikContainerTextProps.dart';
import '../../props/UikIconProps.dart';
import '../../props/UikImageProps.dart';
import '../../props/UikTextProps.dart';

UikAccordionProps $UikAccordionPropsFromJson(Map<String, dynamic> json) {
  final UikAccordionProps uikAccordionProps = UikAccordionProps();
  final String? id = jsonConvert.convert<String>(json['id']);
  if (id != null) {
    uikAccordionProps.id = id;
  }

  final String? headerBackgroundColor =
      jsonConvert.convert<String>(json['headerBackgroundColor']);
  if (headerBackgroundColor != null) {
    uikAccordionProps.headerBackgroundColor = headerBackgroundColor.toColor();
  }

  final String? contentBackgroundColor =
      jsonConvert.convert<String>(json['contentBackgroundColor']);
  if (contentBackgroundColor != null) {
    uikAccordionProps.contentBackgroundColor = contentBackgroundColor.toColor();
  }

  final String? contentBorderColor =
      jsonConvert.convert<String>(json['contentBorderColor']);
  if (contentBorderColor != null) {
    uikAccordionProps.contentBorderColor = contentBorderColor.toColor();
  }

  final double? headerBorderRadius =
      jsonConvert.convert<double>(json['headerBorderRadius']);
  if (headerBorderRadius != null) {
    uikAccordionProps.headerBorderRadius = headerBorderRadius;
  }

  final double? opacity = jsonConvert.convert<double>(json['opacity']);
  if (opacity != null) {
    uikAccordionProps.opacity = opacity;
  }

  final double? paddingListBottom =
      jsonConvert.convert<double>(json['paddingListBottom']);
  if (paddingListBottom != null) {
    uikAccordionProps.paddingListBottom = paddingListBottom;
  }

  final double? paddingListTop =
      jsonConvert.convert<double>(json['paddingListTop']);
  if (paddingListTop != null) {
    uikAccordionProps.paddingListTop = paddingListTop;
  }

  final double? contentHorizontalPadding =
      jsonConvert.convert<double>(json['contentHorizontalPadding']);
  if (contentHorizontalPadding != null) {
    uikAccordionProps.contentHorizontalPadding = contentHorizontalPadding;
  }

  final double? contentVerticalPadding =
      jsonConvert.convert<double>(json['contentVerticalPadding']);
  if (contentVerticalPadding != null) {
    uikAccordionProps.contentVerticalPadding = contentVerticalPadding;
  }

  final String? headerComponent =
      jsonConvert.convert<String>(json['headerComponent']);

  if (headerComponent != null) {
    if (json['headerComponent']["id"] == "containerText") {
      uikAccordionProps.headerComponent = UikContainerText(
          WidgetType.UikContainerText,
          UikContainerTextProps.fromJson(json['headerComponent']));
    }
  }

  final String? contentComponent =
      jsonConvert.convert<String>(json['contentComponent']);

  if (contentComponent != null) {
    if (json['contentComponent']["id"] == "containerText") {
      uikAccordionProps.contentComponent = UikContainerText(
          WidgetType.UikContainerText,
          UikContainerTextProps.fromJson(json['contentComponent']));
    }
    if (json['contentComponent']["id"] == "text") {
      uikAccordionProps.contentComponent = UikText(
          WidgetType.UikText, UikTextProps.fromJson(json['contentComponent']));
    }
  }

  final String? rightComponent =
      jsonConvert.convert<String>(json['rightComponent']);

  if (rightComponent != null) {
    if (json['rightComponent']["id"] == "image") {
      uikAccordionProps.rightComponent = UikImage(
          WidgetType.UikText, UikImageProps.fromJson(json['rightComponent']));
    }

    if (json['rightComponent']["id"] == "icon") {
      uikAccordionProps.rightComponent = UikIcon(
          WidgetType.UikText, UikIconProps.fromJson(json['rightComponent']));
    }
  }

  final UikAction? action = jsonConvert.convert<UikAction>(json['action']);
  if (action != null) {
    uikAccordionProps.action = action;
  }
  return uikAccordionProps;
}
