import 'package:ui_sdk/components/UikHomeCardEight.dart';
import 'package:ui_sdk/components/UikHomeCardSix.dart';
import 'package:ui_sdk/components/UikHomeCardTwelve.dart';
import 'package:ui_sdk/components/UikProductCardBig.dart';

import 'package:ui_sdk/components/UikProductImageTitlePriceCard.dart';
//import 'package:ui_sdk/components/UikProductCardBig.dart';

import 'package:ui_sdk/generated/json/base/json_convert_content.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:ui_sdk/props/UikHomeCardEightProps.dart';
import 'package:ui_sdk/props/UikHomeCardTwelveProps.dart';
import 'package:ui_sdk/props/UikProductCardBigProps.dart';
import 'package:ui_sdk/props/UikProductCardGridProps.dart';

import '../../components/UikHomeCardTen.dart';

import 'package:ui_sdk/props/UikProductImageTitlePriceCardProps.dart';
import 'package:ui_sdk/props/UikTextProps.dart';

import '../../components/UikHomeCardTwo.dart';
import '../../components/UikImage.dart';
import '../../components/WidgetType.dart';
import '../../props/UikHomeCardSixProps.dart';
import '../../props/UikHomeCardTenProps.dart';
import '../../props/UikHomeCardTwoProps.dart';
import '../../props/UikImageProps.dart';

UikProductCardGridProps $UikProductCardGridPropsFromJson(
    Map<String, dynamic> json) {
  print("entering");
  final UikProductCardGridProps uikProductCardGridProps =
      UikProductCardGridProps();
  final String? id = jsonConvert.convert<String>(json['id']);
  if (id != null) {
    uikProductCardGridProps.id = id;
  }

  final List<dynamic>? productCards =
      jsonConvert.convert<List<dynamic>>(json['productCards']);
  // print(productCards);
  if (productCards != null) {
    for (int i = 0; i < productCards.length; i++) {
      if (json['productCards'][i]['id'] == 'productCard') {
        uikProductCardGridProps.productCards.add(UikProductImageTitlePriceCard(
            WidgetType.UikText,
            UikProductImageTitlePriceCardProps.fromJson(productCards[i])));
      } else if (json['productCards'][0]['id'] == 'HomeCardSix') {
        uikProductCardGridProps.productCards.add(
          UikHomeCardSix(
            WidgetType.UikText,
            UikHomeCardSixProps.fromJson(productCards[i]),
          ),
        );
      } else if (json['productCards'][0]['id'] == 'HomeCardTen') {
        uikProductCardGridProps.productCards.add(
          UikHomeCardTen(
            WidgetType.UikText,
            UikHomeCardTenProps.fromJson(productCards[i]),
          ),
        );
      } else if (json['productCards'][0]['id'] == 'HomeCardTwelve') {
        uikProductCardGridProps.productCards.add(
          UikHomeCardTwelve(
            WidgetType.UikText,
            UikHomeCardTwelveProps.fromJson(productCards[i]),
          ),
        );
      } else if (json['productCards'][0]['id'] == 'HomeCardTwo') {
        uikProductCardGridProps.productCards.add(
          UikHomeCardTwo(
            WidgetType.UikText,
            UikHomeCardTwoProps.fromJson(productCards[i]),
          ),
        );
      } else if (json['productCards'][0]['id'] == 'UikImage') {
        uikProductCardGridProps.productCards.add(
          UikImage(
            WidgetType.UikText,
            UikImageProps.fromJson(productCards[i]),
          ),
        );
      } else {
        uikProductCardGridProps.productCards.add(
          UikProductCardBig(
            WidgetType.UikText,
            UikProductCardBigProps.fromJson(productCards[i]),
          ),
        );
      }
    }
    // print(productCards.length);
  }

  final double? width = jsonConvert.convert<double>(json['width']);
  if (width != null) {
    uikProductCardGridProps.width = width;
  }

  final double? topMargin = jsonConvert.convert<double>(json['topMargin']);
  if (topMargin != null) {
    uikProductCardGridProps.topMargin = topMargin;
  }
  final double? leftMargin = jsonConvert.convert<double>(json['leftMargin']);
  if (leftMargin != null) {
    uikProductCardGridProps.leftMargin = leftMargin;
  }
  final double? rightMargin = jsonConvert.convert<double>(json['rightMargin']);
  if (rightMargin != null) {
    uikProductCardGridProps.rightMargin = rightMargin;
  }

  final double? height = jsonConvert.convert<double>(json['height']);
  if (height != null) {
    uikProductCardGridProps.height = height;
  }
  // print(gridWidth);

  final double? childAspectRatio =
      jsonConvert.convert<double>(json['childAspectRatio']);
  if (childAspectRatio != null) {
    uikProductCardGridProps.childAspectRatio = childAspectRatio;
  }

  final int? crossAxisCount = jsonConvert.convert<int>(json['crossAxisCount']);
  print("crossAxisCount ${crossAxisCount}");
  print("id ${id}");
  if (crossAxisCount != null) {
    uikProductCardGridProps.crossAxisCount = crossAxisCount;
  }

  final double? leftPadding = jsonConvert.convert<double>(json['leftPadding']);
  if (leftPadding != null) {
    uikProductCardGridProps.leftPadding = leftPadding;
  }

  final double? bottomMargin =
      jsonConvert.convert<double>(json['bottomMargin']);
  if (bottomMargin != null) {
    uikProductCardGridProps.bottomMargin = bottomMargin;
  }

  final UikAction? action = jsonConvert.convert<UikAction>(json['action']);
  if (action != null) {
    uikProductCardGridProps.action = action;
  }

  final bool? isScrollable = jsonConvert.convert<bool>(json["isScrollable"]);
  if (isScrollable != null) {
    uikProductCardGridProps.isScrollable = isScrollable;
  }

  return uikProductCardGridProps;
}
