import 'package:ui_sdk/components/UikContainerText.dart';
import 'package:ui_sdk/components/UikIcon.dart';
import 'package:ui_sdk/components/UikTwoComponentRow.dart';
import 'package:ui_sdk/generated/json/base/json_convert_content.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:ui_sdk/props/UikIconProps.dart';
import '../../components/UikRadioButton.dart';
import '../../components/UikText.dart';
import '../../components/WidgetType.dart';
import '../../props/UikContainerTextProps.dart';
import '../../props/UikProductInfornationCompprops.dart';
import '../../props/UikRadioButtonProps.dart';
import '../../props/UikTextProps.dart';
import '../../props/UikTextRadioButtonProps.dart';
import '../../props/UikThreeComponentRowProps.dart';
import '../../props/UikTwoComponentRowProps.dart';

UikProductInformationCompProps $UikProductInformationCompPropsFromJson(
    Map<String, dynamic> json) {
  final UikProductInformationCompProps uikProductInformationCompProps =
      UikProductInformationCompProps();
  final String? id = jsonConvert.convert<String>(json['id']);
  if (id != null) {
    uikProductInformationCompProps.id = id;
  }

  final UikAction? action = jsonConvert.convert<UikAction>(json['action']);
  if (action != null) {
    uikProductInformationCompProps.action = action;
  }

  final String? icon = jsonConvert.convert<String>(json['icon']);
  if (icon != null) {
    uikProductInformationCompProps.icon =
        UikIcon(WidgetType.UikText, UikIconProps.fromJson(json['icon']));
  }

  final String? productInformation =
      jsonConvert.convert<String>(json['productInformation']);
  if (productInformation != null) {
    uikProductInformationCompProps.productInformation = UikContainerText(
        WidgetType.UikText,
        UikContainerTextProps.fromJson(json['productInformation']));
  }

  final String? measurements =
      jsonConvert.convert<String>(json['measurements']);
  if (measurements != null) {
    uikProductInformationCompProps.measurements = UikContainerText(
        WidgetType.UikText,
        UikContainerTextProps.fromJson(json['measurements']));
  }

  final String? height = jsonConvert.convert<String>(json['height']);
  if (height != null) {
    uikProductInformationCompProps.height = UikTwoComponentRow(
        WidgetType.UikText, UikTwoComponentRowProps.fromJson(json['height']));
  }

  final String? width = jsonConvert.convert<String>(json['width']);
  if (width != null) {
    uikProductInformationCompProps.width = UikTwoComponentRow(
        WidgetType.UikText, UikTwoComponentRowProps.fromJson(json['width']));
  }

  final String? depth = jsonConvert.convert<String>(json['depth']);
  if (depth != null) {
    uikProductInformationCompProps.depth = UikTwoComponentRow(
        WidgetType.UikText, UikTwoComponentRowProps.fromJson(json['depth']));
  }

  final String? weight = jsonConvert.convert<String>(json['weight']);
  if (weight != null) {
    uikProductInformationCompProps.weight = UikTwoComponentRow(
        WidgetType.UikText, UikTwoComponentRowProps.fromJson(json['weight']));
  }

  final String? composition = jsonConvert.convert<String>(json['composition']);
  if (composition != null) {
    uikProductInformationCompProps.composition = UikContainerText(
        WidgetType.UikText,
        UikContainerTextProps.fromJson(json['composition']));
  }

  final String? mainmaterial =
      jsonConvert.convert<String>(json['mainmaterial']);
  if (mainmaterial != null) {
    uikProductInformationCompProps.mainmaterial = UikTwoComponentRow(
        WidgetType.UikText,
        UikTwoComponentRowProps.fromJson(json['mainmaterial']));
  }

  final String? weight2 = jsonConvert.convert<String>(json['weight2']);
  if (weight2 != null) {
    uikProductInformationCompProps.weight2 = UikTwoComponentRow(
        WidgetType.UikText, UikTwoComponentRowProps.fromJson(json['weight2']));
  }

  return uikProductInformationCompProps;
}
