import 'package:ui_sdk/generated/json/base/json_convert_content.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:ui_sdk/props/UikButtonProps.dart';
import 'package:ui_sdk/props/UikRowListItemProps.dart';
import 'package:flutter/material.dart';
import 'package:ui_sdk/utils/extensions.dart';

import '../../components/UikIcon.dart';
import '../../components/UikText.dart';
import '../../components/WidgetType.dart';
import '../../props/UikIconProps.dart';
import '../../props/UikTextProps.dart';

UikRowListItemProps $UikRowListItemPropsFromJson(Map<String, dynamic> json) {
  final UikRowListItemProps uikRowListItemProps = UikRowListItemProps();
  final String? id = jsonConvert.convert<String>(json['id']);
  if (id != null) {
    uikRowListItemProps.id = id;
  }
  final String? text = jsonConvert.convert<String>(json['text']);
  if (text != null) {
    uikRowListItemProps.text =
        UikText(WidgetType.UikText, UikTextProps.fromJson(json["text"]));
  }

  final String? icon = jsonConvert.convert<String>(json['icon']);
  if (icon != null) {
    uikRowListItemProps.icon =
        UikIcon(WidgetType.UikText, UikIconProps.fromJson(json["icon"]));
  }


  final double? leftMargin = jsonConvert.convert<double>(json["leftMargin"]);
  final double? rightMargin = jsonConvert.convert<double>(json["rightMargin"]);
  final double? topMargin = jsonConvert.convert<double>(json["topMargin"]);
  final double? bottomMargin =
      jsonConvert.convert<double>(json["bottomMargin"]);

  final double? spaceBetween =
      jsonConvert.convert<double>(json["spaceBetween"]);

  if (leftMargin != null) {
    uikRowListItemProps.leftMargin = leftMargin;
  }
  if (topMargin != null) {
    uikRowListItemProps.topMargin = topMargin;
  }
  if (bottomMargin != null) {
    uikRowListItemProps.bottomMargin = bottomMargin;
  }
  if (rightMargin != null) {
    uikRowListItemProps.rightMargin = rightMargin;
  }
  if (spaceBetween != null) {
    uikRowListItemProps.spaceBetween = spaceBetween;
  }

  final UikAction? action = jsonConvert.convert<UikAction>(json['action']);
  if (action != null) {
    uikRowListItemProps.action = action;
  }
  return uikRowListItemProps;
}
