import 'package:flutter/cupertino.dart';
import 'package:ui_sdk/components/UikColumn.dart';
import 'package:ui_sdk/components/UikHomeCardFive.dart';
import 'package:ui_sdk/components/UikHomeCardFour.dart';
import 'package:ui_sdk/components/UikHomeCardOne.dart';
import 'package:ui_sdk/components/UikHomeCardThree.dart';
import 'package:ui_sdk/components/UikImage.dart';
import 'package:ui_sdk/components/UikText.dart';
import 'package:ui_sdk/components/UikThreeTextCard.dart';
import 'package:ui_sdk/components/UikTwoComponentRow.dart';
import 'package:ui_sdk/generated/json/base/json_convert_content.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:ui_sdk/props/UikButtonProps.dart';
import 'package:ui_sdk/props/UikColumnProps.dart';
import 'package:ui_sdk/props/UikHomeCardFourProps.dart';
import 'package:ui_sdk/props/UikHomeCardOneProps.dart';
import 'package:ui_sdk/props/UikHomeCardThreeProps.dart';
import 'package:ui_sdk/props/UikScrollProductsProps.dart';
import 'package:ui_sdk/props/UikTextProps.dart';
import 'package:ui_sdk/props/UikTwoComponentRowProps.dart';

import '../../components/UikHomeCardEight.dart';
import '../../components/UikHomeCardEleven.dart';
import '../../components/UikHomeCardNine.dart';
import '../../components/UikHomeCardTen.dart';
import '../../components/UikProduct.dart';
import '../../components/WidgetType.dart';
import '../../props/UikHomeCardEightProps.dart';
import '../../props/UikHomeCardElevenProps.dart';
import '../../props/UikHomeCardFiveProps.dart';
import '../../props/UikHomeCardNineProps.dart';
import '../../props/UikHomeCardTenProps.dart';
import '../../props/UikProductProps.dart';
import '../../props/UikImageProps.dart';
import '../../props/UikThreeTextCardProps.dart';

UikScrollProductsProps $UikScrollProductsPropsFromJson(
    Map<String, dynamic> json) {
  print("jsonByLavesh ${json}");
  final UikScrollProductsProps uikScrollProductsProps =
      UikScrollProductsProps();

  final List<dynamic>? items =
      jsonConvert.convert<List<dynamic>>(json['items']);
  final String? type = jsonConvert.convert<String>(json['type']);
  print("laveshlaveshlavesh  ${type}");
  if (items != null) {
    for (int i = 0; i < items.length; i++) {
      if (type == itemType_image) {
        uikScrollProductsProps.items.add(
            UikImage(WidgetType.UikText, UikImageProps.fromJson(items[i])));
      } else if (type == itemType_product_card) {
        uikScrollProductsProps.items.add(UikHomeCardEleven(
            WidgetType.UikText, UikHomeCardElevenProps.fromJson(items[i])));
      } else if (type == itemType_row) {
        uikScrollProductsProps.items.add(UikTwoComponentRow(
            WidgetType.UikText, UikTwoComponentRowProps.fromJson(items[i])));
      } else if (type == itemType_three_text_column) {
        uikScrollProductsProps.items.add(UikThreeTextCard(
            WidgetType.UikText, UikThreeTextCardProps.fromJson(items[i])));
      } else {
        uikScrollProductsProps.items.add(
            UikImage(WidgetType.UikText, UikImageProps.fromJson(items[i])));
      }
    }
  }

  final String? scrollAxis = jsonConvert.convert<String>(json['scrollAxis']);
  if (scrollAxis != null) {
    if (scrollAxis == "Axis.vertical") {
      uikScrollProductsProps.scrollAxis = Axis.vertical;
    }
    if (scrollAxis == "Axis.horizontal") {
      uikScrollProductsProps.scrollAxis = Axis.horizontal;
    }
  }

  final String? id = jsonConvert.convert<String>(json['id']);
  if (id != null) {
    uikScrollProductsProps.id = id;
  }

  final double? height = jsonConvert.convert<double>(json['height']);
  if (height != null) {
    uikScrollProductsProps.height = height;
  }
  final double? topMargin = jsonConvert.convert<double>(json['topMargin']);
  if (topMargin != null) {
    uikScrollProductsProps.topMargin = topMargin;
  }
  final double? bottomMargin =
      jsonConvert.convert<double>(json['bottomMargin']);
  if (bottomMargin != null) {
    uikScrollProductsProps.bottomMargin = bottomMargin;
  }
  final double? leftMargin = jsonConvert.convert<double>(json['leftMargin']);
  if (leftMargin != null) {
    uikScrollProductsProps.leftMargin = leftMargin;
  }
  final double? rightMargin = jsonConvert.convert<double>(json['rightMargin']);
  if (rightMargin != null) {
    uikScrollProductsProps.rightMargin = rightMargin;
  }
  final double? topHeadingMargin =
      jsonConvert.convert<double>(json['topHeadingMargin']);
  if (topHeadingMargin != null) {
    uikScrollProductsProps.topHeadingMargin = topHeadingMargin;
  }
  final double? bottomHeadingMargin =
      jsonConvert.convert<double>(json['bottomHeadingMargin']);
  if (bottomHeadingMargin != null) {
    uikScrollProductsProps.bottomHeadingMargin = bottomHeadingMargin;
  }
  final double? leftHeadingMargin =
      jsonConvert.convert<double>(json['leftHeadingMargin']);
  if (leftHeadingMargin != null) {
    uikScrollProductsProps.leftHeadingMargin = leftHeadingMargin;
  }
  final double? rightHeadingMargin =
      jsonConvert.convert<double>(json['rightHeadingMargin']);
  if (rightHeadingMargin != null) {
    uikScrollProductsProps.rightHeadingMargin = rightHeadingMargin;
  }
  final double? width = jsonConvert.convert<double>(json['width']);
  if (width != null) {
    uikScrollProductsProps.width = width;
  }

  final double? headingWidth =
      jsonConvert.convert<double>(json['headingWidth']);
  if (headingWidth != null) {
    uikScrollProductsProps.headingWidth = headingWidth;
  }
  final double? headingHeight =
      jsonConvert.convert<double>(json['headingHeight']);
  if (headingHeight != null) {
    uikScrollProductsProps.headingHeight = headingHeight;
  }
  final double? gapBetweenItems =
      jsonConvert.convert<double>(json['gapBetweenItems']);
  if (gapBetweenItems != null) {
    uikScrollProductsProps.gapBetweenItems = gapBetweenItems;
  }

  final String? heading = jsonConvert.convert<String>(json['heading']);
  print(heading);
  if (heading != null) {
    uikScrollProductsProps.heading = UikText(
      WidgetType.UikText,
      UikTextProps.fromJson(
        json['heading'],
      ),
    );
  }
  final UikAction? action = jsonConvert.convert<UikAction>(json['action']);
  if (action != null) {
    uikScrollProductsProps.action = action;
  }
  return uikScrollProductsProps;
}
