import 'package:ui_sdk/components/UikText.dart';
import 'package:ui_sdk/generated/json/base/json_convert_content.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:ui_sdk/props/UikAvatarProps.dart';
import 'package:ui_sdk/props/UikButtonProps.dart';
import 'package:ui_sdk/props/UikTagsProps.dart';
import 'package:ui_sdk/props/UikTextProps.dart';
import 'package:flutter/material.dart';

import '../../components/UikAvatar.dart';
import '../../components/WidgetType.dart';

UikTagsProps $UikTagsPropsFromJson(Map<String, dynamic> json) {
  final UikTagsProps uikTagsProps = UikTagsProps();
  final String? id = jsonConvert.convert<String>(json['id']);
  if (id != null) {
    uikTagsProps.id = id;
  }

  final double? width = jsonConvert.convert<double>(json['width']);
  if (width != null) {
    uikTagsProps.width = width;
  }

  final double? height = jsonConvert.convert<double>(json['height']);
  if (height != null) {
    uikTagsProps.height = height;
  }

  final String? avatar = jsonConvert.convert<String>(json['avatar']);

  if (avatar != null) {
    uikTagsProps.avatar =
        UikAvatar(WidgetType.UikText, UikAvatarProps.fromJson(json['avatar']));
  }

  final String? text = jsonConvert.convert<String>(json['text']);
  if (text != null) {
    uikTagsProps.text =
        UikText(WidgetType.UikText, UikTextProps.fromJson(json['text']));
  }

  final String? textColor = jsonConvert.convert<String>(json['textColor']);
  if (textColor != null) {
    uikTagsProps.textColor = Color(int.parse(textColor));
  }

  final String? backgroundColor =
      jsonConvert.convert<String>(json['backgroundColor']);
  if (backgroundColor != null) {
    uikTagsProps.backgroundColor = Color(int.parse(backgroundColor));
  }

  final String? borderColor = jsonConvert.convert<String>(json['borderColor']);
  if (borderColor != null) {
    uikTagsProps.borderColor = Color(int.parse(borderColor));
  }

  final UikAction? action = jsonConvert.convert<UikAction>(json['action']);
  if (action != null) {
    uikTagsProps.action = action;
  }
  return uikTagsProps;
}
