import 'dart:convert';
import 'package:flutter/material.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:ui_sdk/props/WidgetProps.dart';
import '../generated/json/uik_column_props.g.dart';

class UikColumnProps extends WidgetProps {
  late String id;
  late double height = 0.0;
  late List<Widget> widgets = [];
  late double leftMargin = 0.0;
  late double topMargin = 0.0;
  late double rightMargin = 0.0;
  late double bottomMargin = 0.0;
  late UikAction action;

  UikColumnProps();
  factory UikColumnProps.fromJson(Map<String, dynamic> json) =>
      $UikColumnPropsFromJson(json);

  Map<String, dynamic> toJson() => $UikColumnPropsToJson(this);

  @override
  String toString() {
    return jsonEncode(this);
  }
}
