import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:ui_sdk/generated/json/base/json_field.dart';

import '../generated/json/uik_earning_card_props.g.dart';
import '../models/Action.dart';
import 'WidgetProps.dart';

@JsonSerializable()
class UikEarningCardProps extends WidgetProps {
  late String id;
  late UikAction action;
  late Widget leading = const SizedBox();
  late Widget title = const SizedBox();
  late Widget subTitle = const SizedBox();
  late Widget trailing = const SizedBox();
  late double marginLeft = 0.0;
  late double marginRight = 0.0;
  late double marginTop = 0.0;
  late double marginBottom = 0.0;
  late double paddingTop = 0.0;
  late double paddingLeft = 0.0;
  late double paddingBottom = 0.0;
  late double paddingRight = 0.0;
  late Widget bottomLeftTitle = const SizedBox();
  late Widget bottomLeftSubTitle = const SizedBox();
  late Widget bottomRightTitle = const SizedBox();
  late Widget bottomRightSubTitle = const SizedBox();
  late int activeLeads = 0;
  late int pendingLeads = 0;
  UikEarningCardProps();

  factory UikEarningCardProps.fromJson(Map<String, dynamic> json) =>
      $UikEarningCardPropsFromJson(json);

  @override
  String toString() {
    return jsonEncode(this);
  }
}
