import 'dart:convert';
import 'package:flutter/material.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:ui_sdk/props/WidgetProps.dart';
import '../generated/json/uik_Row_props.g.dart';

class UikRowProps extends WidgetProps {
  late String id;
  late List<Widget> widgets = [];
  late double leftMargin = 0.0;
  late double topMargin = 0.0;
  late double rightMargin = 0.0;
  late double bottomMargin = 0.0;
  late UikAction action;

  UikRowProps();
  factory UikRowProps.fromJson(Map<String, dynamic> json) =>
      $UikRowPropsFromJson(json);

  Map<String, dynamic> toJson() => $UikRowPropsToJson(this);

  @override
  String toString() {
    return jsonEncode(this);
  }
}
