import 'dart:convert';
import 'dart:ui';
import 'package:ui_sdk/generated/json/base/json_field.dart';
import 'package:ui_sdk/generated/json/uik_text_props.g.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:flutter/material.dart';

import '../generated/json/uik_RowText_props.g.dart';
import '../generated/json/uik_divider_props.g.dart';
import 'WidgetProps.dart';

@JsonSerializable()
class UikRowTextProps extends WidgetProps {
  late String id;
  late UikAction action;
  late String? text;
  late Widget? icon;
  late double width = 0.0;
  late double height = 0.0;
  late double leftMargin = 10.0;
  late double rightMargin = 10.0;
  late double topMargin = 10.0;
  late double bottomMargin = 10.0;
  late FontWeight? fontWeight = FontWeight.bold;
  late String fontFamily = "Poppins";
  late double size = 20.0;
  late Color color = Colors.black;

  UikRowTextProps();

  factory UikRowTextProps.fromJson(Map<String, dynamic> json) =>
      $UikRowTextPropsFromJson(json);

  @override
  String toString() {
    return jsonEncode(this);
  }
}
