import 'dart:convert';
import 'package:ui_sdk/generated/json/base/json_field.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:flutter/material.dart';

import '../generated/json/uik_threeComponentRow_props.g.dart';
import 'WidgetProps.dart';

@JsonSerializable()
class UikThreeComponentRowProps extends WidgetProps {
  late String id;
  late UikAction action;
  late Widget? middletext;
  late Widget? icon;
  late Widget? endtext = null;
  double marginLeft;
  double marginRight;
  double marginTop;
  double marginBottom;

  UikThreeComponentRowProps({
    this.marginBottom = 0.0,
    this.marginLeft = 0.0,
    this.marginRight = 0.0,
    this.marginTop = 0.0,
  });

  factory UikThreeComponentRowProps.fromJson(Map<String, dynamic> json) =>
      $UikThreeComponentRowPropsFromJson(json);

  @override
  String toString() {
    return jsonEncode(this);
  }
}
